/*******************************************************************************
* File Name: BRAKE.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_BRAKE_H) /* Pins BRAKE_H */
#define CY_PINS_BRAKE_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "BRAKE_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 BRAKE__PORT == 15 && ((BRAKE__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    BRAKE_Write(uint8 value);
void    BRAKE_SetDriveMode(uint8 mode);
uint8   BRAKE_ReadDataReg(void);
uint8   BRAKE_Read(void);
void    BRAKE_SetInterruptMode(uint16 position, uint16 mode);
uint8   BRAKE_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the BRAKE_SetDriveMode() function.
     *  @{
     */
        #define BRAKE_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define BRAKE_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define BRAKE_DM_RES_UP          PIN_DM_RES_UP
        #define BRAKE_DM_RES_DWN         PIN_DM_RES_DWN
        #define BRAKE_DM_OD_LO           PIN_DM_OD_LO
        #define BRAKE_DM_OD_HI           PIN_DM_OD_HI
        #define BRAKE_DM_STRONG          PIN_DM_STRONG
        #define BRAKE_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define BRAKE_MASK               BRAKE__MASK
#define BRAKE_SHIFT              BRAKE__SHIFT
#define BRAKE_WIDTH              1u

/* Interrupt constants */
#if defined(BRAKE__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in BRAKE_SetInterruptMode() function.
     *  @{
     */
        #define BRAKE_INTR_NONE      (uint16)(0x0000u)
        #define BRAKE_INTR_RISING    (uint16)(0x0001u)
        #define BRAKE_INTR_FALLING   (uint16)(0x0002u)
        #define BRAKE_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define BRAKE_INTR_MASK      (0x01u) 
#endif /* (BRAKE__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define BRAKE_PS                     (* (reg8 *) BRAKE__PS)
/* Data Register */
#define BRAKE_DR                     (* (reg8 *) BRAKE__DR)
/* Port Number */
#define BRAKE_PRT_NUM                (* (reg8 *) BRAKE__PRT) 
/* Connect to Analog Globals */                                                  
#define BRAKE_AG                     (* (reg8 *) BRAKE__AG)                       
/* Analog MUX bux enable */
#define BRAKE_AMUX                   (* (reg8 *) BRAKE__AMUX) 
/* Bidirectional Enable */                                                        
#define BRAKE_BIE                    (* (reg8 *) BRAKE__BIE)
/* Bit-mask for Aliased Register Access */
#define BRAKE_BIT_MASK               (* (reg8 *) BRAKE__BIT_MASK)
/* Bypass Enable */
#define BRAKE_BYP                    (* (reg8 *) BRAKE__BYP)
/* Port wide control signals */                                                   
#define BRAKE_CTL                    (* (reg8 *) BRAKE__CTL)
/* Drive Modes */
#define BRAKE_DM0                    (* (reg8 *) BRAKE__DM0) 
#define BRAKE_DM1                    (* (reg8 *) BRAKE__DM1)
#define BRAKE_DM2                    (* (reg8 *) BRAKE__DM2) 
/* Input Buffer Disable Override */
#define BRAKE_INP_DIS                (* (reg8 *) BRAKE__INP_DIS)
/* LCD Common or Segment Drive */
#define BRAKE_LCD_COM_SEG            (* (reg8 *) BRAKE__LCD_COM_SEG)
/* Enable Segment LCD */
#define BRAKE_LCD_EN                 (* (reg8 *) BRAKE__LCD_EN)
/* Slew Rate Control */
#define BRAKE_SLW                    (* (reg8 *) BRAKE__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define BRAKE_PRTDSI__CAPS_SEL       (* (reg8 *) BRAKE__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define BRAKE_PRTDSI__DBL_SYNC_IN    (* (reg8 *) BRAKE__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define BRAKE_PRTDSI__OE_SEL0        (* (reg8 *) BRAKE__PRTDSI__OE_SEL0) 
#define BRAKE_PRTDSI__OE_SEL1        (* (reg8 *) BRAKE__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define BRAKE_PRTDSI__OUT_SEL0       (* (reg8 *) BRAKE__PRTDSI__OUT_SEL0) 
#define BRAKE_PRTDSI__OUT_SEL1       (* (reg8 *) BRAKE__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define BRAKE_PRTDSI__SYNC_OUT       (* (reg8 *) BRAKE__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(BRAKE__SIO_CFG)
    #define BRAKE_SIO_HYST_EN        (* (reg8 *) BRAKE__SIO_HYST_EN)
    #define BRAKE_SIO_REG_HIFREQ     (* (reg8 *) BRAKE__SIO_REG_HIFREQ)
    #define BRAKE_SIO_CFG            (* (reg8 *) BRAKE__SIO_CFG)
    #define BRAKE_SIO_DIFF           (* (reg8 *) BRAKE__SIO_DIFF)
#endif /* (BRAKE__SIO_CFG) */

/* Interrupt Registers */
#if defined(BRAKE__INTSTAT)
    #define BRAKE_INTSTAT            (* (reg8 *) BRAKE__INTSTAT)
    #define BRAKE_SNAP               (* (reg8 *) BRAKE__SNAP)
    
	#define BRAKE_0_INTTYPE_REG 		(* (reg8 *) BRAKE__0__INTTYPE)
#endif /* (BRAKE__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_BRAKE_H */


/* [] END OF FILE */
