/*******************************************************************************
* File Name: EZI2C_PORT.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_EZI2C_PORT_ALIASES_H) /* Pins EZI2C_PORT_ALIASES_H */
#define CY_PINS_EZI2C_PORT_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"


/***************************************
*              Constants        
***************************************/
#define EZI2C_PORT_0			(EZI2C_PORT__0__PC)
#define EZI2C_PORT_0_INTR	((uint16)((uint16)0x0001u << EZI2C_PORT__0__SHIFT))

#define EZI2C_PORT_1			(EZI2C_PORT__1__PC)
#define EZI2C_PORT_1_INTR	((uint16)((uint16)0x0001u << EZI2C_PORT__1__SHIFT))

#define EZI2C_PORT_INTR_ALL	 ((uint16)(EZI2C_PORT_0_INTR| EZI2C_PORT_1_INTR))
#define EZI2C_PORT_scl			(EZI2C_PORT__scl__PC)
#define EZI2C_PORT_scl_INTR	((uint16)((uint16)0x0001u << EZI2C_PORT__0__SHIFT))

#define EZI2C_PORT_sda			(EZI2C_PORT__sda__PC)
#define EZI2C_PORT_sda_INTR	((uint16)((uint16)0x0001u << EZI2C_PORT__1__SHIFT))

#endif /* End Pins EZI2C_PORT_ALIASES_H */


/* [] END OF FILE */
