/*******************************************************************************
* File Name: HAL_RIGHT_BAK.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_HAL_RIGHT_BAK_H) /* Pins HAL_RIGHT_BAK_H */
#define CY_PINS_HAL_RIGHT_BAK_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "HAL_RIGHT_BAK_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 HAL_RIGHT_BAK__PORT == 15 && ((HAL_RIGHT_BAK__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    HAL_RIGHT_BAK_Write(uint8 value);
void    HAL_RIGHT_BAK_SetDriveMode(uint8 mode);
uint8   HAL_RIGHT_BAK_ReadDataReg(void);
uint8   HAL_RIGHT_BAK_Read(void);
void    HAL_RIGHT_BAK_SetInterruptMode(uint16 position, uint16 mode);
uint8   HAL_RIGHT_BAK_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the HAL_RIGHT_BAK_SetDriveMode() function.
     *  @{
     */
        #define HAL_RIGHT_BAK_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define HAL_RIGHT_BAK_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define HAL_RIGHT_BAK_DM_RES_UP          PIN_DM_RES_UP
        #define HAL_RIGHT_BAK_DM_RES_DWN         PIN_DM_RES_DWN
        #define HAL_RIGHT_BAK_DM_OD_LO           PIN_DM_OD_LO
        #define HAL_RIGHT_BAK_DM_OD_HI           PIN_DM_OD_HI
        #define HAL_RIGHT_BAK_DM_STRONG          PIN_DM_STRONG
        #define HAL_RIGHT_BAK_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define HAL_RIGHT_BAK_MASK               HAL_RIGHT_BAK__MASK
#define HAL_RIGHT_BAK_SHIFT              HAL_RIGHT_BAK__SHIFT
#define HAL_RIGHT_BAK_WIDTH              1u

/* Interrupt constants */
#if defined(HAL_RIGHT_BAK__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in HAL_RIGHT_BAK_SetInterruptMode() function.
     *  @{
     */
        #define HAL_RIGHT_BAK_INTR_NONE      (uint16)(0x0000u)
        #define HAL_RIGHT_BAK_INTR_RISING    (uint16)(0x0001u)
        #define HAL_RIGHT_BAK_INTR_FALLING   (uint16)(0x0002u)
        #define HAL_RIGHT_BAK_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define HAL_RIGHT_BAK_INTR_MASK      (0x01u) 
#endif /* (HAL_RIGHT_BAK__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define HAL_RIGHT_BAK_PS                     (* (reg8 *) HAL_RIGHT_BAK__PS)
/* Data Register */
#define HAL_RIGHT_BAK_DR                     (* (reg8 *) HAL_RIGHT_BAK__DR)
/* Port Number */
#define HAL_RIGHT_BAK_PRT_NUM                (* (reg8 *) HAL_RIGHT_BAK__PRT) 
/* Connect to Analog Globals */                                                  
#define HAL_RIGHT_BAK_AG                     (* (reg8 *) HAL_RIGHT_BAK__AG)                       
/* Analog MUX bux enable */
#define HAL_RIGHT_BAK_AMUX                   (* (reg8 *) HAL_RIGHT_BAK__AMUX) 
/* Bidirectional Enable */                                                        
#define HAL_RIGHT_BAK_BIE                    (* (reg8 *) HAL_RIGHT_BAK__BIE)
/* Bit-mask for Aliased Register Access */
#define HAL_RIGHT_BAK_BIT_MASK               (* (reg8 *) HAL_RIGHT_BAK__BIT_MASK)
/* Bypass Enable */
#define HAL_RIGHT_BAK_BYP                    (* (reg8 *) HAL_RIGHT_BAK__BYP)
/* Port wide control signals */                                                   
#define HAL_RIGHT_BAK_CTL                    (* (reg8 *) HAL_RIGHT_BAK__CTL)
/* Drive Modes */
#define HAL_RIGHT_BAK_DM0                    (* (reg8 *) HAL_RIGHT_BAK__DM0) 
#define HAL_RIGHT_BAK_DM1                    (* (reg8 *) HAL_RIGHT_BAK__DM1)
#define HAL_RIGHT_BAK_DM2                    (* (reg8 *) HAL_RIGHT_BAK__DM2) 
/* Input Buffer Disable Override */
#define HAL_RIGHT_BAK_INP_DIS                (* (reg8 *) HAL_RIGHT_BAK__INP_DIS)
/* LCD Common or Segment Drive */
#define HAL_RIGHT_BAK_LCD_COM_SEG            (* (reg8 *) HAL_RIGHT_BAK__LCD_COM_SEG)
/* Enable Segment LCD */
#define HAL_RIGHT_BAK_LCD_EN                 (* (reg8 *) HAL_RIGHT_BAK__LCD_EN)
/* Slew Rate Control */
#define HAL_RIGHT_BAK_SLW                    (* (reg8 *) HAL_RIGHT_BAK__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define HAL_RIGHT_BAK_PRTDSI__CAPS_SEL       (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define HAL_RIGHT_BAK_PRTDSI__DBL_SYNC_IN    (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define HAL_RIGHT_BAK_PRTDSI__OE_SEL0        (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__OE_SEL0) 
#define HAL_RIGHT_BAK_PRTDSI__OE_SEL1        (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define HAL_RIGHT_BAK_PRTDSI__OUT_SEL0       (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__OUT_SEL0) 
#define HAL_RIGHT_BAK_PRTDSI__OUT_SEL1       (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define HAL_RIGHT_BAK_PRTDSI__SYNC_OUT       (* (reg8 *) HAL_RIGHT_BAK__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(HAL_RIGHT_BAK__SIO_CFG)
    #define HAL_RIGHT_BAK_SIO_HYST_EN        (* (reg8 *) HAL_RIGHT_BAK__SIO_HYST_EN)
    #define HAL_RIGHT_BAK_SIO_REG_HIFREQ     (* (reg8 *) HAL_RIGHT_BAK__SIO_REG_HIFREQ)
    #define HAL_RIGHT_BAK_SIO_CFG            (* (reg8 *) HAL_RIGHT_BAK__SIO_CFG)
    #define HAL_RIGHT_BAK_SIO_DIFF           (* (reg8 *) HAL_RIGHT_BAK__SIO_DIFF)
#endif /* (HAL_RIGHT_BAK__SIO_CFG) */

/* Interrupt Registers */
#if defined(HAL_RIGHT_BAK__INTSTAT)
    #define HAL_RIGHT_BAK_INTSTAT            (* (reg8 *) HAL_RIGHT_BAK__INTSTAT)
    #define HAL_RIGHT_BAK_SNAP               (* (reg8 *) HAL_RIGHT_BAK__SNAP)
    
	#define HAL_RIGHT_BAK_0_INTTYPE_REG 		(* (reg8 *) HAL_RIGHT_BAK__0__INTTYPE)
#endif /* (HAL_RIGHT_BAK__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_HAL_RIGHT_BAK_H */


/* [] END OF FILE */
