/*******************************************************************************
* File Name: ISR1s.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_ISR1s_H)
#define CY_ISR_ISR1s_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void ISR1s_Start(void);
void ISR1s_StartEx(cyisraddress address);
void ISR1s_Stop(void);

CY_ISR_PROTO(ISR1s_Interrupt);

void ISR1s_SetVector(cyisraddress address);
cyisraddress ISR1s_GetVector(void);

void ISR1s_SetPriority(uint8 priority);
uint8 ISR1s_GetPriority(void);

void ISR1s_Enable(void);
uint8 ISR1s_GetState(void);
void ISR1s_Disable(void);

void ISR1s_SetPending(void);
void ISR1s_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ISR1s ISR. */
#define ISR1s_INTC_VECTOR            ((reg32 *) ISR1s__INTC_VECT)

/* Address of the ISR1s ISR priority. */
#define ISR1s_INTC_PRIOR             ((reg8 *) ISR1s__INTC_PRIOR_REG)

/* Priority of the ISR1s interrupt. */
#define ISR1s_INTC_PRIOR_NUMBER      ISR1s__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ISR1s interrupt. */
#define ISR1s_INTC_SET_EN            ((reg32 *) ISR1s__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ISR1s interrupt. */
#define ISR1s_INTC_CLR_EN            ((reg32 *) ISR1s__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ISR1s interrupt state to pending. */
#define ISR1s_INTC_SET_PD            ((reg32 *) ISR1s__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ISR1s interrupt. */
#define ISR1s_INTC_CLR_PD            ((reg32 *) ISR1s__INTC_CLR_PD_REG)


#endif /* CY_ISR_ISR1s_H */


/* [] END OF FILE */
