/*******************************************************************************
* File Name: ISR5s.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_ISR5s_H)
#define CY_ISR_ISR5s_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void ISR5s_Start(void);
void ISR5s_StartEx(cyisraddress address);
void ISR5s_Stop(void);

CY_ISR_PROTO(ISR5s_Interrupt);

void ISR5s_SetVector(cyisraddress address);
cyisraddress ISR5s_GetVector(void);

void ISR5s_SetPriority(uint8 priority);
uint8 ISR5s_GetPriority(void);

void ISR5s_Enable(void);
uint8 ISR5s_GetState(void);
void ISR5s_Disable(void);

void ISR5s_SetPending(void);
void ISR5s_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ISR5s ISR. */
#define ISR5s_INTC_VECTOR            ((reg32 *) ISR5s__INTC_VECT)

/* Address of the ISR5s ISR priority. */
#define ISR5s_INTC_PRIOR             ((reg8 *) ISR5s__INTC_PRIOR_REG)

/* Priority of the ISR5s interrupt. */
#define ISR5s_INTC_PRIOR_NUMBER      ISR5s__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ISR5s interrupt. */
#define ISR5s_INTC_SET_EN            ((reg32 *) ISR5s__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ISR5s interrupt. */
#define ISR5s_INTC_CLR_EN            ((reg32 *) ISR5s__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ISR5s interrupt state to pending. */
#define ISR5s_INTC_SET_PD            ((reg32 *) ISR5s__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ISR5s interrupt. */
#define ISR5s_INTC_CLR_PD            ((reg32 *) ISR5s__INTC_CLR_PD_REG)


#endif /* CY_ISR_ISR5s_H */


/* [] END OF FILE */
