/*******************************************************************************
* File Name: ISRtimerXs.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_ISRtimerXs_H)
#define CY_ISR_ISRtimerXs_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void ISRtimerXs_Start(void);
void ISRtimerXs_StartEx(cyisraddress address);
void ISRtimerXs_Stop(void);

CY_ISR_PROTO(ISRtimerXs_Interrupt);

void ISRtimerXs_SetVector(cyisraddress address);
cyisraddress ISRtimerXs_GetVector(void);

void ISRtimerXs_SetPriority(uint8 priority);
uint8 ISRtimerXs_GetPriority(void);

void ISRtimerXs_Enable(void);
uint8 ISRtimerXs_GetState(void);
void ISRtimerXs_Disable(void);

void ISRtimerXs_SetPending(void);
void ISRtimerXs_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the ISRtimerXs ISR. */
#define ISRtimerXs_INTC_VECTOR            ((reg32 *) ISRtimerXs__INTC_VECT)

/* Address of the ISRtimerXs ISR priority. */
#define ISRtimerXs_INTC_PRIOR             ((reg8 *) ISRtimerXs__INTC_PRIOR_REG)

/* Priority of the ISRtimerXs interrupt. */
#define ISRtimerXs_INTC_PRIOR_NUMBER      ISRtimerXs__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable ISRtimerXs interrupt. */
#define ISRtimerXs_INTC_SET_EN            ((reg32 *) ISRtimerXs__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the ISRtimerXs interrupt. */
#define ISRtimerXs_INTC_CLR_EN            ((reg32 *) ISRtimerXs__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the ISRtimerXs interrupt state to pending. */
#define ISRtimerXs_INTC_SET_PD            ((reg32 *) ISRtimerXs__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the ISRtimerXs interrupt. */
#define ISRtimerXs_INTC_CLR_PD            ((reg32 *) ISRtimerXs__INTC_CLR_PD_REG)


#endif /* CY_ISR_ISRtimerXs_H */


/* [] END OF FILE */
