/*******************************************************************************
* File Name: KEY_NO_FRN.h  
* Version 2.20
*
* Description:
*  This file contains Pin function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_KEY_NO_FRN_H) /* Pins KEY_NO_FRN_H */
#define CY_PINS_KEY_NO_FRN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "KEY_NO_FRN_aliases.h"

/* APIs are not generated for P15[7:6] */
#if !(CY_PSOC5A &&\
	 KEY_NO_FRN__PORT == 15 && ((KEY_NO_FRN__MASK & 0xC0) != 0))


/***************************************
*        Function Prototypes             
***************************************/    

/**
* \addtogroup group_general
* @{
*/
void    KEY_NO_FRN_Write(uint8 value);
void    KEY_NO_FRN_SetDriveMode(uint8 mode);
uint8   KEY_NO_FRN_ReadDataReg(void);
uint8   KEY_NO_FRN_Read(void);
void    KEY_NO_FRN_SetInterruptMode(uint16 position, uint16 mode);
uint8   KEY_NO_FRN_ClearInterrupt(void);
/** @} general */

/***************************************
*           API Constants        
***************************************/
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup driveMode Drive mode constants
     * \brief Constants to be passed as "mode" parameter in the KEY_NO_FRN_SetDriveMode() function.
     *  @{
     */
        #define KEY_NO_FRN_DM_ALG_HIZ         PIN_DM_ALG_HIZ
        #define KEY_NO_FRN_DM_DIG_HIZ         PIN_DM_DIG_HIZ
        #define KEY_NO_FRN_DM_RES_UP          PIN_DM_RES_UP
        #define KEY_NO_FRN_DM_RES_DWN         PIN_DM_RES_DWN
        #define KEY_NO_FRN_DM_OD_LO           PIN_DM_OD_LO
        #define KEY_NO_FRN_DM_OD_HI           PIN_DM_OD_HI
        #define KEY_NO_FRN_DM_STRONG          PIN_DM_STRONG
        #define KEY_NO_FRN_DM_RES_UPDWN       PIN_DM_RES_UPDWN
    /** @} driveMode */
/** @} group_constants */
    
/* Digital Port Constants */
#define KEY_NO_FRN_MASK               KEY_NO_FRN__MASK
#define KEY_NO_FRN_SHIFT              KEY_NO_FRN__SHIFT
#define KEY_NO_FRN_WIDTH              1u

/* Interrupt constants */
#if defined(KEY_NO_FRN__INTSTAT)
/**
* \addtogroup group_constants
* @{
*/
    /** \addtogroup intrMode Interrupt constants
     * \brief Constants to be passed as "mode" parameter in KEY_NO_FRN_SetInterruptMode() function.
     *  @{
     */
        #define KEY_NO_FRN_INTR_NONE      (uint16)(0x0000u)
        #define KEY_NO_FRN_INTR_RISING    (uint16)(0x0001u)
        #define KEY_NO_FRN_INTR_FALLING   (uint16)(0x0002u)
        #define KEY_NO_FRN_INTR_BOTH      (uint16)(0x0003u) 
    /** @} intrMode */
/** @} group_constants */

    #define KEY_NO_FRN_INTR_MASK      (0x01u) 
#endif /* (KEY_NO_FRN__INTSTAT) */


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define KEY_NO_FRN_PS                     (* (reg8 *) KEY_NO_FRN__PS)
/* Data Register */
#define KEY_NO_FRN_DR                     (* (reg8 *) KEY_NO_FRN__DR)
/* Port Number */
#define KEY_NO_FRN_PRT_NUM                (* (reg8 *) KEY_NO_FRN__PRT) 
/* Connect to Analog Globals */                                                  
#define KEY_NO_FRN_AG                     (* (reg8 *) KEY_NO_FRN__AG)                       
/* Analog MUX bux enable */
#define KEY_NO_FRN_AMUX                   (* (reg8 *) KEY_NO_FRN__AMUX) 
/* Bidirectional Enable */                                                        
#define KEY_NO_FRN_BIE                    (* (reg8 *) KEY_NO_FRN__BIE)
/* Bit-mask for Aliased Register Access */
#define KEY_NO_FRN_BIT_MASK               (* (reg8 *) KEY_NO_FRN__BIT_MASK)
/* Bypass Enable */
#define KEY_NO_FRN_BYP                    (* (reg8 *) KEY_NO_FRN__BYP)
/* Port wide control signals */                                                   
#define KEY_NO_FRN_CTL                    (* (reg8 *) KEY_NO_FRN__CTL)
/* Drive Modes */
#define KEY_NO_FRN_DM0                    (* (reg8 *) KEY_NO_FRN__DM0) 
#define KEY_NO_FRN_DM1                    (* (reg8 *) KEY_NO_FRN__DM1)
#define KEY_NO_FRN_DM2                    (* (reg8 *) KEY_NO_FRN__DM2) 
/* Input Buffer Disable Override */
#define KEY_NO_FRN_INP_DIS                (* (reg8 *) KEY_NO_FRN__INP_DIS)
/* LCD Common or Segment Drive */
#define KEY_NO_FRN_LCD_COM_SEG            (* (reg8 *) KEY_NO_FRN__LCD_COM_SEG)
/* Enable Segment LCD */
#define KEY_NO_FRN_LCD_EN                 (* (reg8 *) KEY_NO_FRN__LCD_EN)
/* Slew Rate Control */
#define KEY_NO_FRN_SLW                    (* (reg8 *) KEY_NO_FRN__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define KEY_NO_FRN_PRTDSI__CAPS_SEL       (* (reg8 *) KEY_NO_FRN__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define KEY_NO_FRN_PRTDSI__DBL_SYNC_IN    (* (reg8 *) KEY_NO_FRN__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define KEY_NO_FRN_PRTDSI__OE_SEL0        (* (reg8 *) KEY_NO_FRN__PRTDSI__OE_SEL0) 
#define KEY_NO_FRN_PRTDSI__OE_SEL1        (* (reg8 *) KEY_NO_FRN__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define KEY_NO_FRN_PRTDSI__OUT_SEL0       (* (reg8 *) KEY_NO_FRN__PRTDSI__OUT_SEL0) 
#define KEY_NO_FRN_PRTDSI__OUT_SEL1       (* (reg8 *) KEY_NO_FRN__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define KEY_NO_FRN_PRTDSI__SYNC_OUT       (* (reg8 *) KEY_NO_FRN__PRTDSI__SYNC_OUT) 

/* SIO registers */
#if defined(KEY_NO_FRN__SIO_CFG)
    #define KEY_NO_FRN_SIO_HYST_EN        (* (reg8 *) KEY_NO_FRN__SIO_HYST_EN)
    #define KEY_NO_FRN_SIO_REG_HIFREQ     (* (reg8 *) KEY_NO_FRN__SIO_REG_HIFREQ)
    #define KEY_NO_FRN_SIO_CFG            (* (reg8 *) KEY_NO_FRN__SIO_CFG)
    #define KEY_NO_FRN_SIO_DIFF           (* (reg8 *) KEY_NO_FRN__SIO_DIFF)
#endif /* (KEY_NO_FRN__SIO_CFG) */

/* Interrupt Registers */
#if defined(KEY_NO_FRN__INTSTAT)
    #define KEY_NO_FRN_INTSTAT            (* (reg8 *) KEY_NO_FRN__INTSTAT)
    #define KEY_NO_FRN_SNAP               (* (reg8 *) KEY_NO_FRN__SNAP)
    
	#define KEY_NO_FRN_0_INTTYPE_REG 		(* (reg8 *) KEY_NO_FRN__0__INTTYPE)
#endif /* (KEY_NO_FRN__INTSTAT) */

#endif /* CY_PSOC5A... */

#endif /*  CY_PINS_KEY_NO_FRN_H */


/* [] END OF FILE */
