/* ========================================
 *
 * Copyright INOUE SEISAKUSYO CO LTD,DEC 2016
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF INOUE SEISAKUSYO CO LTD.
 ***************************************************
 #Add: Back sensor power ON only when goes backward 2017/8/30
 #Add: GRIP but no movement more than 5s, then BRAKE 2017/9/7
 #Ver2-Add handle error detection
      -Omit physical encoder and replace with function saberSoftStop


 ***************************************************

 *
 * ========================================
*/
#include <project.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>


int8 timeUp=0,GRIP_DIG_FRN=0,zeroSettingCounter=0,time5s=0,time1s=0,t1sStop=1,t5sStart=0;

int16 vrc=0,vrp=0,vrd=0,vlc=0,vlp=0,vld=0,pr=0,pl=0,pre_pr=0,pre_pl=0;
//int16 Data=0,sr=0,sl=0,m1=1;
//int16 velocRabs,velocLabs,vrStopStep=0,vlStopStep=0,vrStop=0,vlStop=0,velocR=0,velocL=0;
//int16 l=550,r=125;
int16 hrd,hld;
    

uint16 HALr=0,HALl=0;
    
       
//int32 VR=0,VL=0,Speed=0,encDatR=0,encDatL=0,encDatR_pre=0,encDatL_pre=0;
    
     

float32 PHI=3.142;

char S1_TX[50],S2_TX[50],s,dbg[15]={0},dbg1[150]={0};
enum LED {RED,GREEN,BLUE,RedBlink,seqRGB} OprLed; 




void indicatorFront(int8 OprLed);
void handleZeroSetting();
void speedSaber(uint8 Motor ,int16 Data );
void saberSoftStop(int16 velocR,int16 velocL);
void hal2SaberSimul();
void speedSaberSimul(int16 vrc_l,int16 vrp_l,int16 vrd_l,int16 vlc_l,int16 vlp_l,int16 vld_l);
//int stopSaber(uint8 Motor);
//int freewheelSaber(uint8 Motor,int16 OnOff);
//void speedSaberSineSimul(int16 vrc,int16 vrp,int16 vrdf,int16 vlc,int16 vlp,int16 vldf);


CY_ISR_PROTO(ISR_TimerXs);
CY_ISR_PROTO(ISR_Timer1s);
CY_ISR_PROTO(ISR_Timer5s);


int main(void)
{
    vrc=0;
    
    CyGlobalIntEnable; /* Enable global interrupts. */
    
    OPR_LED_Write(1u);
    indicatorFront(RED);
    CyDelay(10);
    
    AMux_Start();
    ADC_Start();
    UART_Start();
    ClockX_Start();
    //QuadDecR_Start();
    //QuadDecL_Start();
    TimerXs_Start();
    CyDelay(10);
    
    handleZeroSetting();
    indicatorFront(GREEN);
    ISRtimerXs_StartEx(ISR_TimerXs);
    ISR1s_StartEx(ISR_Timer1s);
    ISR5s_StartEx(ISR_Timer5s);
    
    sprintf(dbg,"start-here-vrc:%d,vrp:%d,vrd:%d,vlc:%d,vlp>%d,vld:%d\r\n",vrc,vrp,vrd,vlc,vlp,vld);UART_PutString(dbg);
    
   
    
    for(;;)
    {
        
        
        GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
        if(GRIP_DIG_FRN){
          indicatorFront(BLUE);
          BRAKE_Write(1);
          sprintf(dbg,"normal-grip\r\n");UART_PutString(dbg);
          /**if(!t5sStart){
            BRAKE_Write(1);
            IndicatorFront(BLUE);
            }**/
          
          hal2SaberSimul();
          //***brake for grip with no operation****
          /**if(encDatR==0 && encDatL==0){
          //if((encDatR>=-100 && encDatR<=100) && (encDatL>=-100 && encDatL<=100) ){  
            if(!t5sStart){
              Timer5s_Start();
              t5sStart=1;
            }
            }else{
                 if(t5sStart){
                   Timer5s_Stop();
                   t5sStart=0;
                 }
            } **/
          //******
            
          }else{
               sprintf(dbg,"no-grip\r\n");UART_PutString(dbg);
            
               //sprintf(dbg,"beforeStop-vrc>%d,vrp>%d,vrd>%d,vlc>%d,vlp>%d,vld>%d\r\n",vrc,vrp,vrd,vlc,vlp,vld);UART_PutString(dbg);
               
               //saberSoftStop(vrp,vlp);
               
               //sprintf(dbg,"afterStop-vrc>%d,vrp>%d,vrd>%d,vlc>%d,vlp>%d,vld>%d\r\n",vrc,vrp,vrd,vlc,vlp,vld);UART_PutString(dbg);
               speedSaber(1,0);speedSaber(2,0);
               BRAKE_Write(0);
               REV_SENSE_Write(0);
               vrp=0;vlp=0; 
               
               sprintf(dbg,"zeroSetCtr>%d\r\n",zeroSettingCounter);UART_PutString(dbg);
               //*** handleZeroSetting interval
               if(zeroSettingCounter>=50){ 
                 zeroSettingCounter=0;
                 handleZeroSetting(); 
               }
               zeroSettingCounter++;
               
               //*******************************
               indicatorFront(GREEN);
        }
        
        
    }
    return 0;
}

CY_ISR(ISR_TimerXs)
{
    //sprintf(dbg,"*10ms***\r\n");UART_PutString(dbg);
    timeUp=1;
    //encReadCalc();
}

CY_ISR(ISR_Timer1s)
{
    if(time1s>10)
      {time1s=10;}
    time1s++;
    //sprintf(dbg,"ttt%d\r\n",time1s);UART_PutString(dbg);
}

CY_ISR(ISR_Timer5s)
{
    if(time5s>60)
      {time5s=10;}
    time5s++;
    //sprintf(dbg,"ttt%d\r\n",time1s);UART_PutString(dbg);
    BRAKE_Write(0);
    indicatorFront(GREEN);
    
}

void handleZeroSetting()
{
    uint8 ctr=0;    
    uint16 halRightFront=0,halLeftFront=0,totHalRightFront=0,totHalLeftFront=0,mid=2047;
    hrd=0,hld=0;
        
    while(ctr <10){
        GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
        if(GRIP_DIG_FRN){
            indicatorFront(RedBlink);
            }else{
                
                AMux_FastSelect(0);
                halRightFront=ADC_Read16();
                totHalRightFront+=halRightFront;
                
                //sprintf(dbg,"zeroSetting>>handleR:%d\r\n",halRightFront);UART_PutString(dbg); 
                
                AMux_FastSelect(1);
                halLeftFront=ADC_Read16();
                totHalLeftFront+=halLeftFront;
                ctr++;   
                
                //sprintf(dbg,"zeroSetting>>handleL:%d\r\n",halLeftFront);UART_PutString(dbg);
                
            }  
    }
    
    //sprintf(dbg,"Total>>ctr:%d,TotR:%lu,TotL:%lu\r\n",ctr,totHalRightFront,totHalLeftFront);UART_PutString(dbg); 
    
    halRightFront=(float)(totHalRightFront/ctr);
    halLeftFront=(float)(totHalLeftFront/ctr);
    
    sprintf(dbg,"zeroSet>ctr:%d,handleR:%d,handleL:%d\r\n",ctr,halRightFront,halLeftFront);UART_PutString(dbg); 
    
    while(halRightFront>3687 || halRightFront<409 || halLeftFront>3687 || halLeftFront<409){
         speedSaber(1,0);speedSaber(2,0);
         BRAKE_Write(0);
         indicatorFront(seqRGB);
    }
    
    hrd=mid-halRightFront;
    hld=mid-halLeftFront;
   
    sprintf(dbg,"zeroSet>hrd>%d,hld>%d\r\n",hrd,hld);UART_PutString(dbg);
    //sprintf(dbg,"handle>HALr:%d,HALrd:%d,HALl:%d,HALld:%d\r\n",halRightFrontFinal,hrd,halLeftFrontFinal,hld);UART_PutString(dbg);
    
    //return 0;
   
    
}


void saberSoftStop(int16 velocR,int16 velocL)//Soft stop without using encoder
{
    //CyDelay(1000);
    int16 velocRabs,velocLabs,vrStopStep=0,vlStopStep=0,vrStop,vlStop;
    
    //sprintf(dbg,"velocR:%d,velocL:%d\r\n",velocR,velocL);UART_PutString(dbg);
    
    if(velocR==0){velocR=1;}
    if(velocL==0){velocL=1;}//avoid infinity in abs value
    velocRabs=abs(velocR);velocLabs=abs(velocL);
    
    if(velocRabs>=velocLabs){vrStopStep=(velocRabs/velocLabs);}
      else if(velocLabs>=velocRabs){vlStopStep=(velocLabs/velocRabs);}
    
    if(vrStopStep==0){vrStopStep=1;}
    if(vlStopStep==0){vlStopStep=1;}//avoid infinity in abs value
    
    
    //sprintf(dbg,"velocRabs:%d,velocLabs:%d\r\n",velocRabs,velocLabs);UART_PutString(dbg);
    //sprintf(dbg,"vrStopStep:%d,vlStopStep:%d\r\n",vrStopStep,vlStopStep);UART_PutString(dbg);
    
  
    
    //(velocR>0 && velocL>0) && (velocRabs>velocLabs)
    if((velocR>0 && velocL>0) && (velocRabs>velocLabs)){
      for(vrStop=velocR,vlStop=velocL;vrStop>0 || vlStop>0;vrStop-=vrStopStep,vlStop--){
      //for(vrStop=velocR,vlStop=velocL;vrStop>0 || vlStop>0;vrStop--,vlStop--){  
         //sprintf(dbg,"vrStop1in:%d,vlStop1in:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
        if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
         speedSaber(1,vrStop);speedSaber(2,vlStop);
         GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
         if(GRIP_DIG_FRN){
            sprintf(dbg,"break1-1\r\n");UART_PutString(dbg);
            //vrp=vrStop;vlp=vlStop;
            break;
         }
         //sprintf(dbg,"vrStop1:%d,vlStop1:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
      }
    //(velocR>0 && velocL>0) && (velocLabs>velocRabs)
    }else if((velocR>0 && velocL>0) && (velocLabs>velocRabs)){
            for(vrStop=velocR,vlStop=velocL;vrStop>0 || vlStop>0;vrStop--,vlStop-=vlStopStep){
            //for(vrStop=velocR,vlStop=velocL;vrStop>0 || vlStop>0;vrStop--,vlStop--){ 
                 if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                 speedSaber(1,vrStop);speedSaber(2,vlStop);
                 GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                 if(GRIP_DIG_FRN){
                   sprintf(dbg,"break1-2\r\n");UART_PutString(dbg);
                   //vrp=vrStop;vlp=vlStop;
                   break;
                 }
                 //sprintf(dbg,"vrStop1-2:%d,vlStop1-2:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
              }
    //(velocR<0 && velocL<0) && (velocRabs>velocLabs)       
    }else if((velocR<0 && velocL<0) && (velocRabs>=velocLabs)){
             for(vrStop=velocR,vlStop=velocL;vrStop<0 || vlStop<0;vrStop+=vrStopStep,vlStop++){
                if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                speedSaber(1,vrStop);speedSaber(2,vlStop);
                GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                if(GRIP_DIG_FRN){
                  sprintf(dbg,"break2-1\r\n");UART_PutString(dbg);
                  //vrp=vrStop;vlp=vlStop;
                  break;
                } 
                //sprintf(dbg,"vrSto2p:%d,vlStop2:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
             }
    //(velocR<0 && velocL<0) && (velocLabs>velocRabs)  
    }else if((velocR<0 && velocL<0) && (velocLabs>=velocRabs)){
              for(vrStop=velocR,vlStop=velocL;vrStop<0 || vlStop<0;vrStop++,vlStop+=vlStopStep){
                 if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                 speedSaber(1,vrStop);speedSaber(2,vlStop);
                 GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                 if(GRIP_DIG_FRN){
                   sprintf(dbg,"break2-2\r\n");UART_PutString(dbg);
                   //vrp=vrStop;vlp=vlStop;
                   break;
                 } 
                 //sprintf(dbg,"vrSto2p:%d,vlStop2:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
                
              }
    //(velocR>0 && velocL<0) && (velocRabs>velocLabs)  
    }else if((velocR>0 && velocL<0) && (velocRabs>=velocLabs)){
              for(vrStop=velocR,vlStop=velocL;vrStop>0 || vlStop<0;vrStop-=vrStopStep,vlStop++){
                 if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                 speedSaber(1,vrStop);speedSaber(2,vlStop);
                 GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                 if(GRIP_DIG_FRN){
                   sprintf(dbg,"break3-1\r\n");UART_PutString(dbg);
                   //vrp=vrStop;vlp=vlStop;
                   break;
                 }
                 //sprintf(dbg,"vrStop3:%d,vlStop3:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
              }
    //(velocR>0 && velocL<0) && (velocLabs>velocRabs)
    }else if((velocR>0 && velocL<0) && (velocLabs>=velocRabs)){
              for(vrStop=velocR,vlStop=velocL;vrStop>0 || vlStop<0;vrStop--,vlStop+=vlStopStep){
                 if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                 speedSaber(1,vrStop);speedSaber(2,vlStop);
                 GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                 if(GRIP_DIG_FRN){
                   sprintf(dbg,"break3-2\r\n");UART_PutString(dbg);
                   //vrp=vrStop;vlp=vlStop;
                   break;
                 }
                 //sprintf(dbg,"vrStop3:%d,vlStop3:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
              }
    //(velocR<0 && velocL>0) && (velocRabs>velocLabs)
    }else if((velocR<0 && velocL>0) && (velocRabs>=velocLabs)){
              for(vrStop=velocR,vlStop=velocL;vrStop<0 || vlStop>0;vrStop+=vrStopStep,vlStop--){
                 if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                 speedSaber(1,vrStop);speedSaber(2,vlStop);
                 GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                 if(GRIP_DIG_FRN){
                   sprintf(dbg,"break4-1\r\n");UART_PutString(dbg);
                   //vrp=vrStop;vlp=vlStop;
                   break;
                 }
                 //sprintf(dbg,"vrStop4:%d,vlStop4:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
              }
    //(velocR<0 && velocL>0) && (velocLabs>velocRabs)
    }else if((velocR<0 && velocL>0) && (velocLabs>=velocRabs)){
              for(vrStop=velocR,vlStop=velocL;vrStop<0 || vlStop>0;vrStop++,vlStop-=vlStopStep){
                 if((vrStop==0) || (vlStop==0)){vrStop=0;vlStop=0;}
                 speedSaber(1,vrStop);speedSaber(2,vlStop);
                 GRIP_DIG_FRN=!GRIP_DIG_FRN_Read();
                 if(GRIP_DIG_FRN){
                   sprintf(dbg,"break4-2\r\n");UART_PutString(dbg);
                   //vrp=vrStop;vlp=vlStop;
                   break;
                 }
                 //sprintf(dbg,"vrStop4:%d,vlStop4:%d\r\n",vrStop,vlStop);UART_PutString(dbg);
              }
    }else{
         vrStop=0;vlStop=0;
         //vrp=vrStop;vlp=vlStop;
         speedSaber(1,vrStop);speedSaber(2,vlStop);
         sprintf(dbg,"saberSoftStop--else\r\n");UART_PutString(dbg);
    }
    //return 0;
}



void hal2SaberSimul()
{
    
    //sprintf(dbg,"enter-hal2SaberSimul>hrd>%d,hld>%d\r\n",hrd,hld);UART_PutString(dbg);
            
    int8 ctr=0;
    int16 HAL_RIGHT_FRN=0,HAL_LEFT_FRN=0,HALr=0,HALl=0,wHAL1=0,vHAL1=0;
    int32 totHAL_RIGHT_FRN=0,totHAL_LEFT_FRN=0;
    int16 vHAL2=0,wHAL2=0,vr=0,vl=0,vr1=0,vl1=0,vr2=0,vl2=0;//,tHAL=0;
    
    
    
    while(ctr<20){
         AMux_FastSelect(0);
         HAL_RIGHT_FRN=ADC_Read16();
         totHAL_RIGHT_FRN+=HAL_RIGHT_FRN;
         
         AMux_FastSelect(1);
         HAL_LEFT_FRN=ADC_Read16();
         totHAL_LEFT_FRN+=HAL_LEFT_FRN;
         
         //sprintf(dbg,"halR>%d,halL>%d\r\n",HAL_RIGHT_FRN, HAL_LEFT_FRN);UART_PutString(dbg);  
        
         ctr++;
        
    }
      
    
    HALr=(((float)(totHAL_RIGHT_FRN/ctr))+hrd);//+HAL_RightFrontDiff;
    HALl=(((float)(totHAL_LEFT_FRN/ctr))+hld);//+HAL_LeftFrontDiff;
    
    //sprintf(dbg,"test-float>ctr2>%d,hrd>%d,halR>%d,totHalR>%lu,hld>%d,halL>%d\r\n",ctr,hrd,HALr,totHAL_RIGHT_FRN,hld,HALl);UART_PutString(dbg);
    sprintf(dbg,"mid-of-hal2SaberSimul>hrd>%d,halR>%d,hld>%d,halL>%d\r\n",hrd,HALr,hld,HALl);UART_PutString(dbg);
       
    
    //sprintf(dbg1,"handle>HALr:%d,HALrd:%d,HALl:%d,HALld:%d\r\n",halRightFront,hrd,halLeftFront,hld);UART_PutString(dbg1); 
    //sprintf(dbg,"saber>HALr:%d,HALrd:%d,HALl:%d,HALld:%d\r\n",HALr,hrd,HALl,hld);UART_PutString(dbg); 
    //sprintf(dbg,"in-vr2:%d,vl2:%d\r\n",HALr,HALl);UART_PutString(dbg);
    wHAL1=HALr-HALl;
    //sprintf(dbg,"in-vr2:%d,vl2:%d\r\n",HALr,HALl);UART_PutString(dbg);
    wHAL2=(float)(wHAL1*PHI)/(2*4095);//heading in rad
    //tHAL=(float)(90*wHAL1)/4095;//heading in degree
    wHAL2=(float)wHAL2*1.5;
    
    //sprintf(dbg,"in-vr2:%d,vl2:%d\r\n",HALr,HALl);UART_PutString(dbg);
    
    vHAL1=((HALr+HALl)/2)-2047;// centered to zero
    vHAL2=(float)((vHAL1*1570)/2047);//max linear velocity is 1570 mm/s(2047-->1570)
    vHAL2=(float)(vHAL2*cos(wHAL2)); //velocity with heading direction compensation     
    
    sprintf(dbg,"in-vHAL1:%d,vHAL2:%hd\r\n",vHAL1,vHAL2);UART_PutString(dbg);
    
    vr=(float)((2.0*vHAL2)+(wHAL2*550.0))/(2.0*125.0);//[rad/sec]
    vl=(float)((2.0*vHAL2)-(wHAL2*550.0))/(2.0*125.0);//[rad/sec]
    
    sprintf(dbg,"in-vr:%hd,vl:%hd\r\n",vr,vl);UART_PutString(dbg); 
            
    vr1=(float)(vr*2047.0)/(4.0*PHI);//convert to [mm/s]
    vl1=(float)(vl*2047.0)/(4.0*PHI);
    vr2=(float)vr1*1.7000;//applying gain
    vl2=(float)vl1*1.7000;
    
    sprintf(dbg,"in-vr2:%hd,vl2:%hd\r\n",vr2,vl2);UART_PutString(dbg); 
    
    if(vr2<0 && vl2<0){//slow speed for backward movement
      if(vr2<-200 && vl2<-200){
        REV_SENSE_Write(1);
      }
      vr2=(float)(vr2*0.8);
      vl2=(float)(vl2*0.8);
      }else{
           REV_SENSE_Write(0);
    }
    //sprintf(dbg,"in-vr2:%d,vl2:%d\r\n",vr2,vl2);UART_PutString(dbg); 
    //accelaration-----------------
    if(vr2>400 && vl2>400){
      if(t1sStop){
        Timer1s_Start();
        //ISR1s_StartEx(ISR_Timer1s);
        t1sStop=0;
      }
      vr2=(float)(vr2*(1+(time1s*0.3)));//accellaration coefficient
      vl2=(float)(vl2*(1+(time1s*0.3)));
      }else{
           if(!t1sStop){
             Timer1s_Stop();
             //ISR1s_Stop();
             t1sStop=1;
             time1s=0;
           }   
    }
       
    
    //----------------
    
    
    //prevent out ranging-start
    if (vr2>=2047){vr2=2047;}
        else if(vr2<=-2047)
           {vr2=-2047;}
    
    if (vl2>=2047){vl2=2047;}
        else if(vl2<=-2047)
           {vl2=-2047;}  
    //prevent out ranging-end
    
    vrc=vr2;vrd=vrc-vrp;
    vlc=vl2;vld=vlc-vlp;
        
    sprintf(dbg,"preSimul-vrp:%d,vrc:%d,vrd:%d,vlp:%d,vlc:%d,vld:%d\r\n",vrp,vrc,vrd,vlp,vlc,vld);UART_PutString(dbg); 
    //sprintf(dbg,"out-vr2:%d,vl2:%d,t1sStop:%d,pl:%d\r\n",vr2,vl2,t1sStop,pl);UART_PutString(dbg);    
    speedSaberSimul(vrc,vrp,vrd,vlc,vlp,vld);
   
    vrp=pre_pr;
    vlp=pre_pl;
    
    sprintf(dbg,"return-vrp:%d,vlp:%d\r\n",vrp,vlp);UART_PutString(dbg);
    //sprintf(dbg,"out-vr2:%d,vl2:%d,t1sStop:%d,pl:%d\r\n",vr2,vl2,t1sStop,pl);UART_PutString(dbg);    
    //return 0;   
}

void speedSaber(uint8 Motor,int16 Data)
{
    char kD[16];
    sprintf(kD,"M%u:%d\r\n",Motor,Data);UART_PutString(kD);
    CyDelay(1);
    //return 0;
}

/**void stopSaber(uint8 Motor)
{
    char kD[16];
    sprintf(kD,"M%u:0\r\n",Motor);UART_PutString(kD);
    //CyDelay(1);
}


void freewheelSaber(uint8 Motor,int16 OnOff)
{
    char kD[16];
    sprintf(kD,"Q%u:%d\r\n",Motor,OnOff);UART_PutString(kD);
    //CyDelay(1);
}**/

void speedSaberSimul(int16 vrc_l,int16 vrp_l,int16 vrd_l,int16 vlc_l,int16 vlp_l,int16 vld_l)
{
    int16 vrd_a,vld_a,sr=0,sl=0;
    vrc=vrc_l;vrp=vrp_l;vrd=vrd_l;
    vlc=vlc_l;vlp=vlp_l;vld=vld_l;
    
    //*******applying step ratio
    sprintf(dbg,"inSimul-vrc:%d,vrp:%d,vrdf:%d,vlc:%d,vlp:%d,vldf:%d\r\n",vrc,vrp,vrd,vlc,vlp,vld);UART_PutString(dbg);
    
    if(vrd==0){vrd=1;}
    if(vld==0){vld=1;}//avoiding infinity
        
    vrd_a=abs(vrd);
    vld_a=abs(vld);
        
    if(vrd_a>=350 || vld_a>=350){
      if(vrd_a>=vld_a){
        sl=15;
        sr=(float)((vrd_a/vld_a)*sl);}
        else if(vrd_a<=vld_a){
                sr=15;
                sl=(float)((vld_a/vrd_a)*sr);}
        
    
      }else{
           if(vrd_a>=vld_a){
             sl=5;
             sr=(float)((vrd_a/vld_a)*sl);}
             else if(vrd_a<=vld_a){
                    sr=5;
                    sl=(float)((vld_a/vrd_a)*sr);}
    }
    
    
    //*********************
    
    //sprintf(dbg,"inSimul-sr:%d,sl:%d\r\n",sr,sl);UART_PutString(dbg);
    
    if(vrd_l>=0 && vld_l>=0){
      for(pr=vrp,pl=vlp;pr<=vrc && pl<=vlc;pr+=sr,pl+=sl){
         pre_pr=pr;
         pre_pl=pl;
         speedSaber(1,pr);
         speedSaber(2,pl);
         //sprintf(dbg,"tru1:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
         if(timeUp){
           //sprintf(dbg,"break1:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           timeUp=0;
           break;
        }       
      } 
    }else if(vrd_l>=0 && vld_l<=0){
        for(pr=vrp,pl=vlp;pr<=vrc && pl>=vlc;pr+=sr,pl-=sl){
           pre_pr=pr;
           pre_pl=pl;
           speedSaber(1,pr);
           speedSaber(2,pl);
           //sprintf(dbg,"tru2:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           if(timeUp){
             //sprintf(dbg,"break2:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
             timeUp=0;
             break;
           }
        }
    }else if(vrd_l<=0 && vld_l>=0){
        for(pr=vrp,pl=vlp;pr>=vrc && pl<=vlc;pr-=sr,pl+=sl){
           pre_pr=pr;
           pre_pl=pl;
           speedSaber(1,pr);
           speedSaber(2,pl);
           //sprintf(dbg,"tru3:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           if(timeUp){
             //sprintf(dbg,"break3:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
             timeUp=0;
             break;
           }
        }
    }else if(vrd_l<=0 && vld_l<=0){
        for(pr=vrp,pl=vlp;pr>=vrc && pl>=vlc;pr-=sr,pl-=sl){
           pre_pr=pr;
           pre_pl=pl;
           speedSaber(1,pr);
           speedSaber(2,pl);
           //sprintf(dbg,"tru4:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           if(timeUp){
             //sprintf(dbg,"break4:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
             timeUp=0;
             break;
           }
        }
    }
   
    //sprintf(dbg,"out\r\n");UART_PutString(dbg);
    //return 0;
    
}

/**void speedSineSaberSimul(int16 vrc,int16 vrp,int16 vrdf,int16 vlc,int16 vlp,int16 vldf)
{
    *******applying step ratio
    if(vrdf==0){vrdf=1;}
    if(vldf==0){vldf=1;}//avoiding infinity
    //sprintf(dbg,"inSimul-vrc:%d,vrp:%d,vrdf:%d,vlc:%d,vlp:%d,vldf:%d\r\n",vrc,vrp,vrdf,vlc,vlp,vldf);UART_PutString(dbg);    
    vrdf_a=abs(vrdf);
    vldf_a=abs(vldf);
        
    if(vrdf_a>=350 || vldf_a>=350){
      if(vrdf_a>=vldf_a){
        sl=15;
        sr=(float)((vrdf_a/vldf_a)*sl);}
        else if(vrdf_a<=vldf_a){
                sr=15;
                sl=(float)((vldf_a/vrdf_a)*sr);}
      }else{
           if(vrdf_a>=vldf_a){
             sl=5;
             sr=(float)((vrdf_a/vldf_a)*sl);}
             else if(vrdf_a<=vldf_a){
                    sr=5;
                    sl=(float)((vldf_a/vrdf_a)*sr);}
    }
    
    
    *********************
    
    //sprintf(dbg,"inSimul-sr:%d,sl:%d\r\n",sr,sl);UART_PutString(dbg);
    
    if(vrdf>=0 && vldf>=0){
      for(pr=vrp,pl=vlp;pr<=vrc && pl<=vlc;pr+=sr,pl+=sl){
         pre_pr=pr;
         pre_pl=pl;
         speedSaber(1,pr);
         speedSaber(2,pl);
         //sprintf(dbg,"tru1:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
         if(timeUp){
           //sprintf(dbg,"break1:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           timeUp=0;
           break;
        }       
      } 
    }else if(vrdf>=0 && vldf<=0){
        for(pr=vrp,pl=vlp;pr<=vrc && pl>=vlc;pr+=sr,pl-=sl){
           pre_pr=pr;
           pre_pl=pl;
           speedSaber(1,pr);
           speedSaber(2,pl);
           //sprintf(dbg,"tru2:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           if(timeUp){
             //sprintf(dbg,"break2:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
             timeUp=0;
             break;
           }
        }
    }else if(vrdf<=0 && vldf>=0){
        for(pr=vrp,pl=vlp;pr>=vrc && pl<=vlc;pr-=sr,pl+=sl){
           pre_pr=pr;
           pre_pl=pl;
           speedSaber(1,pr);
           speedSaber(2,pl);
           //sprintf(dbg,"tru3:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           if(timeUp){
             //sprintf(dbg,"break3:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
             timeUp=0;
             break;
           }
        }
    }else if(vrdf<=0 && vldf<=0){
        for(pr=vrp,pl=vlp;pr>=vrc && pl>=vlc;pr-=sr,pl-=sl){
           pre_pr=pr;
           pre_pl=pl;
           speedSaber(1,pr);
           speedSaber(2,pl);
           //sprintf(dbg,"tru4:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
           if(timeUp){
             //sprintf(dbg,"break4:vrp:%d,vrc:%d,pr:%d,vlp:%d,vlc:%d,pl:%d\r\n",vrp,vrc,pr,vlp,vlc,pl);UART_PutString(dbg);
             timeUp=0;
             break;
           }
        }
    }
   
    //sprintf(dbg,"out\r\n");UART_PutString(dbg);
    
    
}**/

void indicatorFront(int8 OprLed)
{
    switch(OprLed){
        case RED:
            IND_GRN_FRN_Write(0u);
            IND_BLU_FRN_Write(0u);
            IND_RED_FRN_Write(1u);
            break;
            
        case GREEN:
            IND_RED_FRN_Write(0u);
            IND_BLU_FRN_Write(0u);
            IND_GRN_FRN_Write(1u);
            break; 
            
        case BLUE:
            IND_RED_FRN_Write(0u);
            IND_GRN_FRN_Write(0u);
            IND_BLU_FRN_Write(1u);
            break;
            
        case RedBlink:
            IND_GRN_FRN_Write(0u);
            IND_BLU_FRN_Write(0u);
            IND_RED_FRN_Write(1u);
            CyDelay(100);
            IND_RED_FRN_Write(0u);
            CyDelay(100);
            break;  
            
        case seqRGB:
            IND_RED_FRN_Write(1u);
            CyDelay(300);
            IND_RED_FRN_Write(0u);
            CyDelay(300);
            
            IND_GRN_FRN_Write(1u);
            CyDelay(300);
            IND_GRN_FRN_Write(0u);
            CyDelay(300);
            
            IND_BLU_FRN_Write(1u);
            CyDelay(300);
            IND_BLU_FRN_Write(0u);
            CyDelay(300);
            break;    
            
    }
    //return 0;
}





/* [] END OF FILE */
